#!/bin/bash

STEP1FN="step1.sql"
STEP2aFN="step2a.sql"
STEP2bFN="step2b.sql"
STEP3FN="step3ff.sql"

# number of rows
nTF=9 		# must be >= 6 
nTM=2000	# 2000
if [ "$#" -eq "1" ]; then
	nTM=$1
fi
echo "Number of rows nTF=$nTF nTM=$nTM"
	
cat > $STEP1FN <<- EOM
-- --------------------------
-- step1 create tables
-- --------------------------

-- structure for table tf
DROP TABLE IF EXISTS tf;
CREATE TABLE IF NOT EXISTS tf (
  id int(10) unsigned NOT NULL AUTO_INCREMENT,
  sid int(10) unsigned NOT NULL DEFAULT '0',
  tp char(10) NOT NULL DEFAULT '0',
  fn varchar(50) NOT NULL DEFAULT '0',
  PRIMARY KEY (id),
  UNIQUE KEY uni (sid,fn),
  KEY sid (sid)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- structure for table tm
DROP TABLE IF EXISTS tm;
CREATE TABLE IF NOT EXISTS tm (
  id int(10) unsigned NOT NULL AUTO_INCREMENT,
  fid int(10) unsigned NOT NULL DEFAULT '0',
  ts int(10) unsigned NOT NULL DEFAULT '999999999',
  te int(10) unsigned NOT NULL DEFAULT '999999999',
  sc varchar(50) NOT NULL DEFAULT '0',
  ky varchar(50) NOT NULL DEFAULT '0',
  PRIMARY KEY (id),
  UNIQUE KEY uni (fid,te,ts,sc,ky),
  KEY ts (ts),
  KEY te (te)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- --------------------------
-- step1 insert test data
-- --------------------------

DELETE FROM tf;
DELETE FROM tm;

EOM

# base of primary keys	
BASEfID=1000
BASEmID=7654321

# start of primary keys	
mid=$BASEmID
fid=$BASEfID
f=1
while [[ $f -le $nTF ]] ; do
	((fid = fid + 1 ))
	echo "INSERT INTO tf (id, sid, tp, fn) VALUES($fid, 302, '$RANDOM', 'fn$f');" >> $STEP1FN
	echo -n "gennerating Step1 $f/$nTF"
	((f = f + 1))
	
	echo "INSERT IGNORE INTO tm (id, fid, ts, te, sc, ky) VALUES" >> $STEP1FN
	m=1
	while [[ $m -le $nTM ]] ; do
		((m % 1000)) || echo -n "."
		((mid = mid + 1 ))
		echo -n "   ($mid, $fid, 1, 999999990, 'sc$fid', 'ky$mid')" >> $STEP1FN
		if [ $m -eq $nTM ] ; then
			echo ";" >> $STEP1FN
		else
			echo "," >> $STEP1FN
		fi	
		((m = m + 1))
	done
	echo ""
done

cat > $STEP2aFN <<- EOM
-- --------------------------------
-- step2a insert other data into tm
-- --------------------------------
EOM

cat > $STEP2bFN <<- EOM
-- -------------------------------
-- step2b delete data from step2.a
-- -------------------------------

DELETE FROM tm WHERE id IN (
EOM

# rewind fID primary keys	
fid=$BASEfID
f=1
SEP=""
while [[ $f -le $nTF ]] ; do
	((fid = fid + 1 ))
	echo -n "gennerating Step2 $f/$nTF"
	((f = f + 1))
	
	echo -n "INSERT IGNORE INTO tm (id, fid, ts, te, sc, ky) VALUES" >> $STEP2aFN
	m=1
	while [[ $m -le $nTM ]] ; do
		((m % 1000)) || echo -n "."
		((mid = mid + 1 ))
		echo -n "   ($mid, $fid, 999999997, 999999997, 'sc$fid', 'ky$mid')" >> $STEP2aFN
		if [ $m -eq $nTM ] ; then
			echo ";" >> $STEP2aFN
		else
			echo "," >> $STEP2aFN
		fi
		echo -ne "$SEP'$mid'" >> $STEP2bFN
		SEP=",\n"
		((m = m + 1))
	done
	echo ""
done
echo ");" >> $STEP2bFN 


echo "gennerating Step3"
cat > $STEP3FN <<- EOM
-- ----------------------------------
-- step3 select some data from step 1
-- ----------------------------------

SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn1' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn1' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn1' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn1' AND tm.ts <= 999999990 AND tm.te >= 999999990;
                
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn2' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn2' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn2' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn2' AND tm.ts <= 999999990 AND tm.te >= 999999990;
                
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn3' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn3' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn3' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn3' AND tm.ts <= 999999990 AND tm.te >= 999999990;
                
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn4' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn4' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn4' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn4' AND tm.ts <= 999999990 AND tm.te >= 999999990;
                
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn6' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn6' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn6' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn6' AND tm.ts <= 999999990 AND tm.te >= 999999990;
                
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn5' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn5' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tf INNER JOIN tm ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn5' AND tm.ts <= 999999990 AND tm.te >= 999999990;
SELECT count(*) FROM tm INNER JOIN tf ON tf.id = tm.fid WHERE tf.sid = 302 AND tf.fn = 'fn5' AND tm.ts <= 999999990 AND tm.te >= 999999990;

EOM
echo "Done"




