#!/bin/bash

#MYSQLCMD="docker exec -i mysqlTEST mysql"
MYSQLCMD="mysql"

DB_NAME="test"

#test files
STEP1FN="step1.sql"
STEP2aFN="step2a.sql"
STEP2bFN="step2b.sql"
STEP3FN="step3ff.sql"
RUNS=10

if [ ! -f "$STEP1FN" ] || [ ! -f "$STEP2aFN" ] || [ ! -f "$STEP2bFN" ] || [ ! -f "$STEP3FN" ]; then 
	./genFiles.sh
fi

#info
$MYSQLCMD --table -e "SHOW GLOBAL VARIABLES LIKE '%version%'"

# prepare
$MYSQLCMD -e "CREATE DATABASE IF NOT EXISTS $DB_NAME"
$MYSQLCMD -D $DB_NAME < $STEP1FN

echo "Expected:" $($MYSQLCMD -BND $DB_NAME < $STEP3FN)

for (( r=0; r<${RUNS}; r++ )); do
	$MYSQLCMD -D $DB_NAME < $STEP2aFN
	$MYSQLCMD -D $DB_NAME < $STEP2bFN
	echo "  run $r :" $($MYSQLCMD -BND $DB_NAME < $STEP3FN)
done

sleep 3
echo "after sleep:" $($MYSQLCMD -BND $DB_NAME < $STEP3FN)
